<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org" xmlns="http://www.w3.org/1999/xhtml">

    <head th:replace="fragments/header :: header">
        <title th:text="#{title}">title</title>
    </head>
    <body>

        <!--Start Container-->
        <div id="main" class="container-fluid">
            <div class="row">

                <th:block th:include="fragments/sidebar :: sidebar('naturalPerson')"></th:block>

                <!--Start Content-->
                <div id="content" class="col-xs-12 col-sm-10">

                    <th:block th:include="fragments/about :: about"></th:block>

                    <!-- Preloader -->
                    <th:block th:include="fragments/preloader :: preloader"></th:block>

                    <!--Start Breadcrumb-->
                    <div class="row">
                        <div id="breadcrumb" class="col-xs-12">

                            <a href="#" class="show-sidebar">
                                <i class="fa fa-bars"></i>
                            </a>

                            <th:block th:insert="breadcrumb :: breadcrumb(breadcrumb)">
                                <ol class="breadcrumb pull-left">
                                    <li><a th:text="#{index}" th:href="@{/index}" href="index.html">index</a></li>
                                    <li th:text="#{knowYourCustomer}">knowYourCustomer</li>
                                    <li><a th:text="#{naturalPerson}" th:href="@{/kyc/naturalPerson}"
                                           href="kyc/naturalPerson.html">naturalPerson</a></li>
                                </ol>
                            </th:block>

                            <!--
                            <ol class="breadcrumb pull-left">
                                <li><a th:href="@{/}" href="index.html">Index</a></li>
                            </ol>-->
                            <div id="social" class="pull-right">
                                <a href="#"><i class="fa fa-google-plus"></i></a>
                                <a href="#"><i class="fa fa-facebook"></i></a>
                                <a href="#"><i class="fa fa-twitter"></i></a>
                                <a href="#"><i class="fa fa-linkedin"></i></a>
                                <a href="#"><i class="fa fa-youtube"></i></a>
                            </div>
                        </div>
                    </div>
                    <!--End Breadcrumb-->


                    <!--Start Dashboard 2-->
                    <div class="row">

                        <div class="col-sm-12">
                            <h2>NexU signature process</h2>

                            <div class="progress">
                                <div class="progress-bar progress-bar-striped active" style="width:0%; height:20px;" id="bar">
                                    <span id="bar-text"></span>
                                </div>
                            </div>
                            <div id="error" style="display:none" class="alert alert-danger" role="danger">
                                <strong id="errorText">Oops... an error occurred </strong><span id="errorcontent"></span>
                            </div>

                            <div class="col-sm-offset-9">
                                <button type="button" class="btn btn-primary btn-lg btn-block" id="submit-button" th:text="#{signatureProcess.signature.button.label}" onclick="getCertificates()">[signatureProcess.signature.button.label]</button>
                            </div>

                        </div>

                        <div class="col-xs-12 col-sm-12">
                            <div class="box">

                                <div class="box-header">
                                    <div class="box-name">
                                        <i class="fa fa-table"></i>
                                        <span th:text="#{signatureProcess.title}">[signatureProcess.title]</span>
                                    </div>
                                    <div class="box-icons">
                                        <a class="collapse-link">
                                            <i class="fa fa-chevron-up"></i>
                                        </a>
                                    </div>
                                    <div class="no-move"></div>
                                </div>
                                <div class="box-content">

                                    <h4 th:text="#{form.table.signatureProcess}" class="page-header">
                                        [form.table.signatureProcess]</h4>

                                    <form class="form-horizontal" th:action="@{/dss/signatureProcess}" method="post" th:object="${signatureProcess}">

                                        <div>
                                            <pre class="prettyprint lang-xml" th:text="${documentToSign}">[documentToSign]</pre>
                                        </div>

                                        <input type="hidden" th:field="*{signedDocument}"/>

                                        <div id="actions" class="col-sm-offset-9" style="margin-top:10px; display:none;">
                                            <button type="submit" class="btn btn-default"
                                                    name="download"
                                                    th:text="#{signatureProcess.download.button.label}">
                                            </button>

                                            <button type="submit" class="btn btn-default"
                                                    name="validate"
                                                    th:text="#{signatureProcess.validate.button.label}">
                                            </button>
                                        </div>
                                    </form>

                                </div>

                            </div>
                        </div>

                        <div class="clearfix"></div>
                    </div>
                    <!--End Dashboard 2 -->

                </div>
                <div class="clearfix"></div>


            </div>
            <!--End Content-->
        </div>
        <!--End Container-->

        <div th:replace="fragments/js :: js">JavaScript</div>

        <script type="text/javascript" th:src="@{/js/nexu-deploy.js}"></script>

        <script type="text/javascript" th:inline="javascript">
            /*<![CDATA[*/
            var tokenId;
            var keyId;
            var signatureParameters = JSON.parse(/*[[${signatureParameters}]]*/ null);
            var documentToSign = /*[[${documentToSign}]]*/ null;
            var DSS_SERVICES_URL = 'http://127.0.0.1:8095/rest/dss/';

            window.onload = function () {
                //Valida el estado de Nexu al cargar la pagina
                nexuStartup();
            };

            function getCertificates() {
                updateProgressBar("Loading certificates...", "10%");
                var purpose = 'nonRepudiation';
                nexu_get_certificates(purpose, getDataToSign, error);
            }

            function getDataToSign(certificateData) {
                if (certificateData.response === null) {
                    $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                    $('#bar-text').html("Error");
                    document.getElementById("errorcontent").innerHTML = "error while reading the Smart Card";
                    $("#error").show();
                } else {
                    updateProgressBar("Computing the digest...", "25%");
                    var signingCertificate = certificateData.response.certificate;
                    var certificateChain = certificateData.response.certificateChain;
                    var encryptionAlgorithm = certificateData.response.encryptionAlgorithm;

                    signatureParameters.signingCertificate = signingCertificate;
                    signatureParameters.certificateChain = certificateChain;
                    signatureParameters.encryptionAlgorithm = encryptionAlgorithm;

                    tokenId = certificateData.response.tokenId.id;
                    keyId = certificateData.response.keyId;
                    var toSend = {signingCertificate: signingCertificate, certificateChain: certificateChain,
                        document: {encodedDocument: signatureParameters.document.encodedDocument, mimeType: signatureParameters.document.mimeType},
                        signWithExpiredCertificate: signatureParameters.signWithExpiredCertificate,
                        signatureLevel: signatureParameters.signatureLevel, signaturePackaging: signatureParameters.signaturePackaging,
                        signatureAlgorithm: signatureParameters.signatureAlgorithm, encryptionAlgorithm: encryptionAlgorithm, digestAlgorithm: signatureParameters.digestAlgorithm,
                        blevelParams: {signingDate: signatureParameters.bLevelParams.signingDate},
                        contentTimestampParameters: {digestAlgorithm: signatureParameters.contentTimestampParameters.digestAlgorithm},
                        signatureTimestampParameters: {digestAlgorithm: signatureParameters.signatureTimestampParameters.digestAlgorithm},
                        archiveTimestampParameters: {digestAlgorithm: signatureParameters.archiveTimestampParameters.digestAlgorithm}};
                    console.log('to data-to-sign: ' + JSON.stringify(toSend));
                    callUrl(DSS_SERVICES_URL + 'data-to-sign', "POST", JSON.stringify(toSend), sign, error);
                }
            }

            function sign(dataToSignResponse) {
                if (dataToSignResponse === null) {
                    $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                    $('#bar-text').html("Error");
                    $("#errorcontent").text("unable to compute the data to sign (see server logs)");
                    $("#error").show();
                } else {
                    updateProgressBar("Signing the digest...", "50%");
                    var digestAlgo = signatureParameters.digestAlgorithm;
                    var dataToSign = dataToSignResponse.response.dataToSign;
                    console.log('to sign: ' + JSON.stringify(dataToSignResponse));
                    console.log('to dataToSign ' + dataToSign);
                    nexu_sign_with_token_infos(tokenId, keyId, dataToSign, digestAlgo, signDocument, error);
                }
            }

            function signDocument(signatureData) {
                updateProgressBar("Signing the document...", "75%");
                var signatureValue = signatureData.response.signatureValue;
                var toSend = {signingCertificate: signatureParameters.signingCertificate, certificateChain: signatureParameters.certificateChain,
                    document: {encodedDocument: signatureParameters.document.encodedDocument, mimeType: signatureParameters.document.mimeType},
                    signatureValue: signatureValue,
                    signWithExpiredCertificate: signatureParameters.signWithExpiredCertificate,
                    signatureLevel: signatureParameters.signatureLevel, signaturePackaging: signatureParameters.signaturePackaging,
                    signatureAlgorithm: signatureParameters.signatureAlgorithm, encryptionAlgorithm: signatureParameters.encryptionAlgorithm, digestAlgorithm: signatureParameters.digestAlgorithm,
                    blevelParams: {signingDate: signatureParameters.bLevelParams.signingDate},
                    contentTimestampParameters: {digestAlgorithm: signatureParameters.contentTimestampParameters.digestAlgorithm},
                    signatureTimestampParameters: {digestAlgorithm: signatureParameters.signatureTimestampParameters.digestAlgorithm},
                    archiveTimestampParameters: {digestAlgorithm: signatureParameters.archiveTimestampParameters.digestAlgorithm}};
                console.log('to sign-document ' + JSON.stringify(toSend));
                callUrl(DSS_SERVICES_URL + '/sign-document', "POST", JSON.stringify(toSend), signatureCompleted, error);
            }

            function signatureCompleted(signDocumentResponse) {
                if (signDocumentResponse === null) {
                    $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                    $('#bar-text').html("Error");
                    $("#errorcontent").text("unable to sign the document(see server logs)");
                    $("#error").show();
                } else {
                    console.log('signatureCompleted ' + JSON.stringify(signDocumentResponse));
                    document.getElementById("signedDocument").value = signDocumentResponse.response.signedDocument;
                    updateProgressBar("Done !", "100%");
                    $('#bar').removeClass('progress-bar-striped active');
                    $('#bar').addClass('progress-bar-success');
                    $("#actions").show();
                }
            }

            function error(error) {
                $('#bar').removeClass('progress-bar-success active').addClass('progress-bar-danger');
                if (error != null && error.responseJSON != null) {
                    var jsonResp = error.responseJSON;
                    if (jsonResp.errorMessage != null) {
                        $("#errorcontent").html(jsonResp.errorMessage);
                    }
                    else if (jsonResp.error != null) {
                        $("#errorcontent").html(jsonResp.error);
                    }
                }
                $("#error").show();
                $("#success").hide();
            }

            function updateProgressBar(action, percent) {
                $('#bar-text').html(action);
                $('#bar').width(percent);
            }
            /*]]>*/
        </script>
    </body>
</html>